<?php

/**
 * reclasif_tit_min actions.
 *
 * @package    cartera
 * @subpackage reclasif_tit_min
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class reclasif_tit_minActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CA_DEBITO_REF_RECLASIF_V',
        'CA_DEBITO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CA_DEBITO,LEFT' =>
        array(
            'id_debito' => 'CA_DEBITO_REF_RECLASIF_V'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CA_DEBITO_REF_RECLASIF_V' =>
        array(
            'id_debito_ref_reclasif' => 'id_debito_ref_reclasif',
            'id_debito' => 'id_debito',
            'secuencia' => 'secuencia',
            'fecha_proceso' => 'fecha_proceso',
            'usuario_log' => 'usuario_log',
            'id_referencia1_ant' => 'id_referencia1_ant',
            'id_referencia1_act' => 'id_referencia1_act',
            'id_referencia2_ant' => 'id_referencia2_ant',
            'id_referencia2_act' => 'id_referencia2_act',
            'cod_mineral_ant' => 'cod_mineral_ant',
            'descripcion_ant' => 'descripcion_ant',
            'mineral_ant' => 'mineral_ant',
            'cod_mineral_act' => 'cod_mineral_act',
            'descripcion_act' => 'descripcion_act',
            'mineral_act' => 'mineral_act',
            'usuariolog_ant' => 'usuariolog_ant',
            'usuario_name_ant' => 'usuario_name_ant',
            'usuariolog_act' => 'usuariolog_act',
            'usuario_name_act' => 'usuario_name_act',
            'cambio_usuario' => 'cambio_usuario'
        ),
        'CA_DEBITO' =>
        array(
            'sec_debito' => 'sec_debito'
        )
    ); //por cada tabla especificar los campos del select
    protected $table_field_conditions = array(
        'CA_DEBITO_REF_RECLASIF_V' => array(
            'id_debito_ref_reclasif,a' => array('!=' => array(-1)),
            'id_debito_ref_reclasif,b' => array('=' => array('id_debito_ref_reclasif')),
            'id_debito' => array('=' => array('id_debito')),
            'secuencia' => array('=' => array('secuencia')),
            'cambio_usuario' => array('=' => array('cambio_usuario')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $query_qualifier = 'DISTINCT'; //eliminar filas repetivas de consulta sql
    protected $fields_orderBy = array(
        'id_debito', 'secuencia'
    ); //campos para el ordenamiento de la consulta

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = false;
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Metodo para add debito ref 
     *
     * @param sfWebRequest $request
     */
    public function executeAdd(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------/  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Variables obligatorias
             */
            $id_debito = $request['id_debito'];
//            $fecha_sistema = $request['fecha_proceso'];
            $fecha_sistema = CN_TABLE::fechaSistema();
//            $id_referencia2_act = $request['id_referencia2_act'];
            //el username desde qebsafiERP
            $usuario = 'admin';
            if (isset($request['username']) && $request['username'] != '') {
                $usuario = $request['username'];
            }

            /*
             * Variables Opcionales
             */
            $id_referencia1_ant = 'null';
            if (isset($request['id_referencia1_ant']) && $request['id_referencia1_ant'] != '') {
                $id_referencia1_ant = $request['id_referencia1_ant'];
            }
            $id_referencia1_act = 'null';
            if (isset($request['id_referencia1_act']) && $request['id_referencia1_act'] != '') {
                $id_referencia1_act = $request['id_referencia1_act'];
            }
            $id_referencia2_ant = 'null';
            if (isset($request['id_referencia2_ant']) && $request['id_referencia2_ant'] != '') {
                $id_referencia2_ant = "'" . $request['id_referencia2_ant'] . "'";
            }
            $id_referencia2_act = 'null';
            if (isset($request['id_referencia2_act']) && $request['id_referencia2_act'] != '') {
                $id_referencia2_act = "'" . $request['id_referencia2_act'] . "'";
            }
            /**
             * Cambio elaborado por ca_debito - 20150423
             */
            $aplica_cambio_user = false;
            $usuariolog_act = 'null';
            if (isset($request['usuariolog_act']) && $request['usuariolog_act'] != '') {
                $usuariolog_act = "'" . $request['usuariolog_act'] . "'";
                $aplica_cambio_user = true;
            }
            $usuariolog_ant = 'null';
            if (isset($request['usuariolog_ant']) && $request['usuariolog_ant'] != '') {
                $usuariolog_ant = "'" . $request['usuariolog_ant'] . "'";
            }

            //sentencia sql ingresar CA_DEBITO
            $sql = <<<EOD
insert into ca_debito_ref_reclasif (id_debito_ref_reclasif,id_debito,
    secuencia,fecha_proceso,usuario_log,id_referencia1_ant,
    id_referencia1_act,id_referencia2_ant,id_referencia2_act, usuariolog_ant, usuariolog_act) 
    values (null,$id_debito,null,to_date('$fecha_sistema','yyyy-mm-dd'),
        '$usuario', $id_referencia1_ant, $id_referencia1_act, 
            $id_referencia2_ant, $id_referencia2_act, $usuariolog_ant, $usuariolog_act)
EOD;

            //ejecuta el sql
            CN_TABLE::executeSQL($sql);


            /**
             * Valida si acutaliza usuarios o referencias - 20150424
             */
            if ($aplica_cambio_user) {
                //actualiza usuarios
                //sentencia sql ingresar CA_DEBITO
                $sql = <<<EOD
update ca_debito set 
    usuariolog = $usuariolog_act
        where id_debito = $id_debito
EOD;

                //ejecuta el sql
                CN_TABLE::executeSQL($sql);
            } else {
                //actualiza referencias
                //sentencia sql
                $sql = <<<EOD
SELECT * FROM ca_debito_ref
WHERE id_debito = $id_debito
EOD;

                //ejecuta el sql
                $result = CN_TABLE::executeSQL($sql);

                /*
                 * Validar que tiene referencia
                 */
                if (count($result) > 0) {
                    //sentencia sql ingresar CA_DEBITO
                    $sql = <<<EOD
update ca_debito_ref set 
    id_referencia1 = $id_referencia1_act
    ,id_referencia2 = $id_referencia2_act
        where id_debito = $id_debito
EOD;

                    //ejecuta el sql
                    CN_TABLE::executeSQL($sql);
                } else {
                    //sentencia sql ingresar CA_DEBITO
                    $sql = <<<EOD
insert into ca_debito_ref (id_debito,id_referencia1,id_referencia2) 
    values ($id_debito, $id_referencia1_act, $id_referencia2_act) 
EOD;

                    //ejecuta el sql
                    CN_TABLE::executeSQL($sql);
                }
            }

            $this->list_data = array();
        } catch (Exception $e) {

            $this->status = 1;
            $this->mensajeError = "ERROR!!!";
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
